import { RAFirebaseOptions } from "../../providers/RAFirebaseOptions";
import { Observable } from "rxjs";
declare type ResetFn = () => void;
declare type IncrementFn = (newReads: number) => void;
interface CounterStreams<TStreamOrSubject extends Observable<number> = Observable<number>> {
    pageReads: TStreamOrSubject;
    lastPageReads: TStreamOrSubject;
    customReads: TStreamOrSubject;
    lastCustomReads: TStreamOrSubject;
    sessionReads: TStreamOrSubject;
    lastSessionReads: TStreamOrSubject;
}
export default class ReadsLogger {
    private storage;
    get pageReads(): number;
    get lastPageReads(): number;
    resetPageReads: ResetFn;
    incrementPageReads: IncrementFn;
    private _lastPageReads;
    private _pageReads;
    get customReads(): number;
    get lastCustomReads(): number;
    resetCustomReads: ResetFn;
    incrementCustomReads: IncrementFn;
    get sessionReads(): number;
    get lastSessionReads(): number;
    resetSessionReads: ResetFn;
    incrementSessionReads: IncrementFn;
    incrementAll: IncrementFn;
    private readonly subjects;
    get streams(): CounterStreams;
    private constructor();
    private initCounterSubjects;
    private static __instance;
    static initLogger(options: RAFirebaseOptions): void;
    static getLogger(): ReadsLogger;
}
export {};
