import { RAFirebaseReadsLoggerStorageKeys } from "./types";
import { RAFirebaseOptions } from "../../providers/RAFirebaseOptions";
import firebase from "firebase/app";
import "firebase/auth";
declare type ReadsKey = 'customReads' | 'sessionReads';
declare type GetReadsFn = (readsKey: keyof RAFirebaseReadsLoggerStorageKeys) => number;
declare type ResetReadsFn = (readsKey: ReadsKey) => void;
declare type IncrementReadsFn = (newReads: number, readsKey: ReadsKey) => void;
export default class ReadsLoggerLocalStorageUtils {
    private readonly options;
    private storageKeys;
    private get hasKeys();
    private readonly loggerOptions;
    private readonly DEFAULT_PREFIX;
    private isInitialized;
    authStateUnsubscribe: firebase.Unsubscribe;
    get keys(): RAFirebaseReadsLoggerStorageKeys;
    getReads: GetReadsFn;
    resetReads: ResetReadsFn;
    incrementReads: IncrementReadsFn;
    init(): Promise<boolean>;
    constructor(options: RAFirebaseOptions);
    private startUserSubscription;
    private setReadsInStorage;
    private getLocalStorageKeys;
    private checkErrors;
    private checkKeysError;
    private checkInitError;
}
export {};
