import { messageTypes } from "../../../misc";
import { ResourceManager } from "../ResourceManager";
import { RAFirebaseOptions } from "../../RAFirebaseOptions";
import ReadsLogger from '../../../misc/reads-logger';
export declare class FirebaseLazyLoadingClient {
    private readonly options;
    private readonly rm;
    private readonly readsLogger;
    constructor(options: RAFirebaseOptions, rm: ResourceManager, readsLogger: ReadsLogger);
    apiGetList(resourceName: string, reactAdminParams: messageTypes.IParamsGetList): Promise<messageTypes.IResponseGetList>;
    apiGetManyReference(resourceName: string, reactAdminParams: messageTypes.IParamsGetManyReference): Promise<messageTypes.IResponseGetManyReference>;
    private paramsToQuery;
    private filtersToQuery;
    private sortToQuery;
    private paginationToQuery;
    private getFullParamsForQuery;
    private getNextPageParams;
    private checkIfOnLastPage;
    private setQueryCursor;
    private getQueryCursor;
    clearQueryCursors(resourceName: string): void;
    private findLastQueryCursor;
    private tryGetResource;
    incrementFirebaseReadsCounter(newReads: number): void;
}
